"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = require("@hint/utils/dist/src/debug");
const meta_1 = require("./meta");
const debug = debug_1.debug(__filename);
class ButtonTypeHint {
    constructor(context) {
        const validateElement = (elementFound) => {
            const { resource } = elementFound;
            const allowedTypes = ['submit', 'reset', 'button'];
            debug(`Validating hint button-type`);
            const element = elementFound.element;
            const elementType = element.getAttribute('type');
            if (elementType === null || elementType === '') {
                context.report(resource, 'Button type attribute has not been set', { element });
            }
            else if (!allowedTypes.includes(elementType.toLowerCase())) {
                context.report(resource, `Invalid button type: ${elementType}`, { element });
            }
        };
        context.on('element::button', validateElement);
    }
}
ButtonTypeHint.meta = meta_1.default;
exports.default = ButtonTypeHint;
